# Китайская игра в палочки.
# Играют два игрока.  Есть 10 палочек. Игроки по очереди берут от одной до трёх палочек.
# Играют до тех пор пока не закончатся палочки. Тот кто взял последним - тот проиграл.
# Реализуйте игру таким образом, чтобы могли играть два человека. Изначально есть 10 палочек.
# На каждом ходу выводите на консоль текущее количество оставшихся палочек и просите ввести количество палочек,
# которое хочет взять игрок (который делает ход). Не забывайте менять очерёдность игроков и
# сокращать кол-во палочек. В конце надо вывести кто победил - первый или второй игрок.
#
# Нюансы реализации могут отличаться. Кто-то может захотет запросить имена у игроков. Кто-то может захотеть
# реализовать не с 10-ю палочками, а с тем количеством, которое введёт пользователь (может он хочет играть с 20-ю палочками?).

who = 0                           # В переменной хранится флаг, который отвечает за то чей сейчас ход
win_1 = 0                         # Кол-во побед игрока1
win_2 = 0                         # Кол-во побед игрока2
sheaf_save = 0                    # Количество палочек в колчане. Нужно для возобновления кол-ва палочек для следующей игры


name1 = str(input('Введите имя игрока1: '))
name2 = str(input('Введите имя игрока2: '))

sheaf = int(input('Введите кол-во палочек: '))
while not 8 <= sheaf <= 30:
    sheaf = int(input('Введите кол-во палочек: '))
sheaf_save = sheaf

rounds = int(input('До скольки побед играем: '))
while not 3 <= rounds <= 20:
    rounds = int(input('До скольки побед играем: '))
print()

def pl_took():                    # Ф-ция вычисляет сколько палочек взял игрок
    global taken                  # Внутри ф-ции работаем с глобальными переменными
    global sheaf
    if taken == 'I':
        taken = 1
    elif taken == 'II':
        taken = 2
    else:
        taken = 3

    sheaf = sheaf - taken         # Вычисление оставшихся палочек в колчане


while True:
    if who == 0:                                    # Ход игрока1
        taken = input(str(name1) + ' берёт: ')
        while not 'I' <= taken <= 'III':            # Проверка на введенное значение
            taken = input(str(name1) + ' берёт: ')
        pl_took()
        if sheaf <= 0:                              # Защита
            sheaf += taken
            continue
        print(name1 + ' взял ' + str(taken) + ' палочки.\nОсталось ' + str(sheaf) + ' палочек.')
        print()

        if sheaf <= 1:                              # Условие выиграша игрока1
            print(name1 + ' выиграл партию!\n')     # Рестарт и перезагрузка значений игры
            sheaf = sheaf_save
            win_1 += 1
            who = 0
            if win_1 == rounds:
                print(name1 + ' выиграл игру!\n' + name1 + ' набрал ' + str(win_1) + ' очков\n' + name2 + ' набрал ' + str(win_2) + ' очков')
                break
            continue
        who += 1                                    # Перадаем ход второму игроку


    elif who == 1:                                  # Ход игрока2
        taken = input(str(name2) + ' берёт: ')
        while not 'I' <= taken <= 'III':            # Проверка на введенное значение
            taken = input(str(name2) + ' берёт: ')
        pl_took()
        if sheaf <= 0:                              # Защита
            sheaf += taken
            continue
        print(name2 + ' взял ' + str(taken) + ' палочки.\nОсталось ' + str(sheaf) + ' палочек.')
        print()

        if sheaf <= 1:                              # Условие выиграша игрока2
            print(name2 + ' выиграл партию!\n')     # Рестарт и перезагрузка значений игры
            sheaf = sheaf_save
            win_2 += 1
            who = 0
            if win_2 == rounds:
                print(name2 + ' выиграл игру!\n' + name1 + ' набрал ' + str(win_1) + ' очков\n' + name2 + ' набрал ' + str(win_2) + ' очков')
                break
            continue
        who -= 1                                    # Перадаем ход первому игроку